// XdrDoc.cpp : implementation of the CXdrDoc class
//

#include "stdafx.h"
#include "XDRMDIVW.h"

#include "XdrDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXdrDoc

IMPLEMENT_DYNCREATE(CXdrDoc, CDocument)

BEGIN_MESSAGE_MAP(CXdrDoc, CDocument)
	//{{AFX_MSG_MAP(CXdrDoc)
	ON_COMMAND(ID_DLGBAR_PREV, OnPrev)
	ON_UPDATE_COMMAND_UI(ID_DLGBAR_PREV, OnUpdatePrev)
	ON_COMMAND(ID_DLGBAR_NEXT, OnNext)
	ON_UPDATE_COMMAND_UI(ID_DLGBAR_NEXT, OnUpdateNext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXdrDoc construction/destruction
// --------------------------------------------------------------------------

CXdrDoc::CXdrDoc() :
   m_wMode(mode_XSL)
{
	// TODO: add one-time construction code here

}

// --------------------------------------------------------------------------

CXdrDoc::~CXdrDoc()
{
}

/////////////////////////////////////////////////////////////////////////////
// CXdrDoc serialization
// --------------------------------------------------------------------------

void CXdrDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CXdrDoc diagnostics
// --------------------------------------------------------------------------

#ifdef _DEBUG
void CXdrDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CXdrDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CXdrDoc commands
// --------------------------------------------------------------------------

BOOL CXdrDoc::OnNewDocument()
{
#if 1 // Cannot create docs, only view them.
   return FALSE;
#else
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
#endif
}

// --------------------------------------------------------------------------

BOOL CXdrDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here

   if ( ( m_wMode & mode_XSL ) == mode_XSL ) // TEMP IMPL ?????????
      {
      LPCTSTR lpszNavigate = lpszPathName ;
      CString strSaveTmpName ;
      // ----
      if ( Internal_MakeTempXdrWithStyleheet( lpszNavigate , strSaveTmpName ) == true )
         {
         if ( Internal_TmpToXml( strSaveTmpName ) == true )
            {
            UpdateAllViews( NULL , static_cast<LPARAM>(upd_Navigate) , reinterpret_cast<CObject *>(const_cast<LPTSTR>(static_cast<LPCTSTR>(m_strTempFileName))) ) ;
            
            // Internal_XmlToTmp( strSaveTmpName ) ;
            }
         }
      }
   else   
	   { UpdateAllViews( NULL , static_cast<LPARAM>(upd_Navigate) , reinterpret_cast<CObject *>(const_cast<LPTSTR>(lpszPathName)) ) ; }
	
	return TRUE;
}

// --------------------------------------------------------------------------

void CXdrDoc::OnCloseDocument() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CString strRemove = m_strTempFileName ; 
   // ----
   CDocument::OnCloseDocument();

   if ( ! strRemove.IsEmpty() )
      {
      try
         {
         CFile::Remove( strRemove ) ;
         }
      catch(...)
         {
         ASSERT(FALSE) ;
         }
      }
}

// --------------------------------------------------------------------------

bool CXdrDoc::Internal_MakeTempXdrWithStyleheet( LPCTSTR   lpszPathName , 
                                                 CString & strSaveTmpName ,
                                                 LPCTSTR   lpszXSL /*=NULL*/ )
{
   CFile          fileXDR ; // Source XML (XDR) file
   CFileException exp ;
   bool           bRet = false ;
   // ----
   m_strTempFileName.Empty() ;

   if ( fileXDR.Open( lpszPathName , CFile::modeRead|CFile::typeBinary , &exp ) != FALSE )
      {
      TCHAR   szTempFileName[_MAX_PATH+1] ;
      UINT    nRet = 0 ;
      // ----
      { // --
      TCHAR szTempPath[_MAX_PATH+1] ; // path buffer
      // ----
      if ( GetTempPath( _MAX_PATH , szTempPath ) > 0 )
         {
         nRet = GetTempFileName( szTempPath ,
                                 _T("XDR") , // file name prefix
                                 0 ,
                                 szTempFileName ) ;
         
         strSaveTmpName = szTempFileName ;
         }
      } // --


      if ( nRet > 0 )
         {
         CString strSourceBuffer ;
         CString strHeader ;
         int     nHeaderLen = 0 ;
         // ----
         if ( Internal_ReadFile( strSourceBuffer , fileXDR ) == true &&
              Internal_SeekXmlHeader( strSourceBuffer , strHeader , nHeaderLen ) == true )
            {
            CString strStyle ;
            CFile   fileTransform ;
            // ----
            if ( Internal_MakeXslTag( strStyle , lpszXSL ) == true )
               {
               try 
                  {
                  fileTransform.Open( szTempFileName , CFile::modeCreate|CFile::modeWrite|CFile::typeBinary ) ;

                  bRet = Internal_WriteFile( fileTransform , strHeader , strStyle , strSourceBuffer ) ;

                  m_strTempFileName = szTempFileName ;
               
                  fileTransform.Close() ;
                  }
               catch (...)
                  {
                  ASSERT(FALSE) ;
                  }
               }
            }
         }
      
      fileXDR.Close() ;
      }

   return bRet ;
}

// --------------------------------------------------------------------------

bool CXdrDoc::Internal_SeekXmlHeader( const CString & strSourceBuffer , CString & strHeader , int & nHeaderLen )
{
   bool bRet = false ;
   // Simplistic parsing
   const int nBegPos = strSourceBuffer.Find( _T("<?") ) ;
   const int nMidPos = strSourceBuffer.Find( _T("xml") ) ;
   const int nEndPos = strSourceBuffer.Find( _T("?>") ) ;
   // ----
   if ( nBegPos >= 0 && nMidPos > nBegPos && nEndPos > nMidPos )
      {
      try
         {
         const int nNumChars = nEndPos + sizeof( _T("?>") ) - 1 ;
         LPTSTR    pzBuffer  = strHeader.GetBuffer( nNumChars + 1 ) ;
         // ----
         if ( pzBuffer != NULL )
            {
            LPCTSTR pczSource = strSourceBuffer ;
            // ----
            memcpy( pzBuffer , pczSource , nNumChars * sizeof(TCHAR) ) ;

            nHeaderLen = nNumChars ;
            
            strHeader.ReleaseBuffer( nNumChars ) ; 

            bRet = true ;
            }
         }
      catch (...)
         {
         }
      }

   return bRet ;
}     

// --------------------------------------------------------------------------

bool CXdrDoc::Internal_ReadFile( CString & strSourceBuffer , CFile & file )
{
   DWORD dwSourceFileLen = file.GetLength() ;
   bool  bRet = false ;
   // ----
   if ( dwSourceFileLen > 0 )
      {
      try
         {
         const int nNumChars = dwSourceFileLen / sizeof(TCHAR) ;
         LPTSTR    pzSource  = strSourceBuffer.GetBuffer( nNumChars + 1 ) ;
         // ----
         if ( pzSource != NULL )
            {
            try
               {
               if ( file.Read( pzSource , dwSourceFileLen ) > 0 )
                  {
                  bRet = true ;
                  }
               }
            catch (...)
               {
               }
            }

         strSourceBuffer.ReleaseBuffer( nNumChars ) ; 
         }
      catch (...)
         {
         }
      }

   return bRet ;
}

// --------------------------------------------------------------------------

bool CXdrDoc::Internal_WriteFile( CFile         & fileDest , 
                                  const CString & strHeader , 
                                  const CString & strStyle , 
                                  const CString & strSourceBuffer )
{
   bool  bRet = false ;
   // ----
   try
      {
      const int nHeaderLen = strHeader.GetLength() ;
      const int nStyleLen  = strStyle.GetLength() ;
      const int nRestLen   = strSourceBuffer.GetLength() - nHeaderLen ;
      LPCTSTR   pczHeader  = strHeader ;
      LPCTSTR   pczStyle   = strStyle ;
      LPCTSTR   pczRest    = static_cast<LPCTSTR>(strSourceBuffer) + nHeaderLen ;


      fileDest.Write( pczHeader , nHeaderLen ) ;
      fileDest.Write( _T("\r\n") , 2 * sizeof(TCHAR) ) ;
      fileDest.Write( pczStyle  , nStyleLen  ) ;
      fileDest.Write( _T("\r\n") , 2 * sizeof(TCHAR) ) ;
      fileDest.Write( pczRest   , nRestLen   ) ;

      bRet = true ;
      }
   catch (...)
      {
      ASSERT(FALSE) ;
      }

   return bRet ;
}

// --------------------------------------------------------------------------

bool CXdrDoc::Internal_TmpToXml( CString & strSaveTmpName )
{
   bool bRet = true ;
   // ----
   strSaveTmpName = m_strTempFileName ;

   try
      {
      const int nFind     = m_strTempFileName.Find( _T(".tmp") ) ;
      LPTSTR    pzBuffer  = m_strTempFileName.GetBuffer( m_strTempFileName.GetLength() ) ;
      // ----
      if ( pzBuffer != NULL )
         {
         _tcscpy( pzBuffer + nFind , _T(".xml") ) ;

         CFile::Rename( strSaveTmpName , m_strTempFileName ) ;
         }
      }
   catch (...)
      {
      ASSERT(FALSE) ;
      bRet = false ;
      }

   return bRet ;
}

// --------------------------------------------------------------------------
#if 0
bool CXdrDoc::Internal_XmlToTmp( CString & strSaveTmpName )
{
   bool bRet = true ;
   // ----
   CFile::Rename( m_strTempFileName , strSaveTmpName ) ;

   strSaveTmpName = m_strTempFileName ;

   return bRet ;
}
#endif
// --------------------------------------------------------------------------

bool CXdrDoc::Internal_MakeXslTag( CString & strXslTag , LPCTSTR lpszXSL /*=NULL*/ )
{
   LPCTSTR pczStyleSheet = lpszXSL == NULL ? _T("xdr-schema.xsl") : lpszXSL ;
   LPCTSTR pczFormat     = _T("<?xml-stylesheet type=\"text/xsl\" href=\"%s\"?>") ;
   // ----
   if ( lpszXSL == NULL )
      {
      TCHAR szFilename[_MAX_PATH+1] ;
      // ----
      if ( ::GetModuleFileName( ::AfxGetApp()->m_hInstance , // handle to module
                                szFilename ,                 // file name of module
                                _MAX_PATH ) > 0 )            // size of buffer
         {
         TCHAR szXslFilename[_MAX_PATH+1] ;
         TCHAR szXslFile[_MAX_FNAME] ;
         TCHAR szXslExt[_MAX_EXT] ;
         //
         TCHAR szDrive[_MAX_DRIVE] ;
         TCHAR szDir[_MAX_DIR] ;
         // ----
         ::_tsplitpath( szFilename , szDrive , szDir , NULL , NULL ) ;

         ::_tsplitpath( pczStyleSheet , NULL , NULL , szXslFile , szXslExt ) ;
 
         ::_tmakepath( szXslFilename , szDrive , szDir , szXslFile , szXslExt ) ;
         
         strXslTag.Format( pczFormat , szXslFilename ) ;
         }
      }
   else
      {
      strXslTag.Format( pczFormat , lpszXSL ) ;
      }

   return true ;
}

// --------------------------------------------------------------------------

void CXdrDoc::OnPrev() 
{
	// TODO: Add your command handler code here
	
   UpdateAllViews( NULL , static_cast<LPARAM>(upd_GoBack) , NULL ) ;
}

// --------------------------------------------------------------------------

void CXdrDoc::OnUpdatePrev(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

   BOOL bCanGo = FALSE ;
   // ----
   UpdateAllViews( NULL , static_cast<LPARAM>(upd_CanGoBack) , reinterpret_cast<CObject *>(&bCanGo) ) ;
}

// --------------------------------------------------------------------------

void CXdrDoc::OnNext() 
{
	// TODO: Add your command handler code here
	
   UpdateAllViews( NULL , static_cast<LPARAM>(upd_GoForward) , NULL ) ;
}

// --------------------------------------------------------------------------

void CXdrDoc::OnUpdateNext(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
   BOOL bCanGo = FALSE ;
   // ----
   UpdateAllViews( NULL , static_cast<LPARAM>(upd_CanGoForward) , reinterpret_cast<CObject *>(&bCanGo) ) ;
}

// --------------------------------------------------------------------------
