// XdrDoc.h : interface of the CXdrDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_XDRDOC_H__DAB34244_D058_4D38_95FF_6AD053ADBE13__INCLUDED_)
#define AFX_XDRDOC_H__DAB34244_D058_4D38_95FF_6AD053ADBE13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CXdrDoc : public CDocument
{
protected: // create from serialization only
	CXdrDoc();
	DECLARE_DYNCREATE(CXdrDoc)

   CString m_strTempFileName ;

// Attributes
public:

	enum UpdateID
   {
   upd_Navigate  = 1 ,
   upd_GoBack    = 2 ,
   upd_GoForward = 3 ,
   upd_CanGoBack    = 4 ,
   upd_CanGoForward = 5 ,
   } ;

	enum Mode
   {
   mode_none = 0x0000 ,
   mode_XSL  = 0x0001 // Apply XSL
   } ;

protected:

   WORD m_wMode ;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CXdrDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CXdrDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

   // Create temporary XML file with stylesheet
   bool Internal_MakeTempXdrWithStyleheet( LPCTSTR lpszPathName , CString & strSaveTmpName , LPCTSTR lpszXSL = NULL ) ;
   bool Internal_SeekXmlHeader( const CString & strSourceBuffer , CString & strHeader , int & nHeaderLen ) ;
   bool Internal_ReadFile( CString & strSourceBuffer , CFile & file ) ;
   bool Internal_WriteFile( CFile & fileDest , const CString & strHeader , const CString & strStyle , const CString & strSourceBuffer  ) ;
   bool Internal_TmpToXml( CString & strSaveTmpName ) ;
   // bool Internal_XmlToTmp( CString & strSaveTmpName ) ;
   bool Internal_MakeXslTag( CString & strXslTag , LPCTSTR lpszXSL = NULL ) ;

// Generated message map functions
protected:
	//{{AFX_MSG(CXdrDoc)
	afx_msg void OnPrev();
	afx_msg void OnUpdatePrev(CCmdUI* pCmdUI);
	afx_msg void OnNext();
	afx_msg void OnUpdateNext(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XDRDOC_H__DAB34244_D058_4D38_95FF_6AD053ADBE13__INCLUDED_)
